package com.example.aped.ui.visualization;


import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import com.android.volley.Response;
import com.example.aped.MainActivity;
import com.example.aped.R;
import org.json.JSONException;
import org.json.JSONObject;
import java.util.ArrayList;
import java.util.List;


public class MainListViewAdapter extends BaseAdapter {
    /**
     * Einbinden der MainActivity.
     */
    private MainActivity mainActivity;
    /**
     * Welche ansicht gewählt wurde 0 für all IOs, 1 für favorite IOs.
     */
    private int favoriteMode;
    /**
     * Name des devices für den aktuellen durchlauf.
     */
    private String deviceName;
    /**
     * Bild für Favorit oder nicht.
     */
    private int favoriteImage;
    /**
     * Liste der beim öffnen der Favoritenansicht bestehenden Favoriten.
     */
    private List<String> favoritenList;


    /**
     * @param pMainActivity
     * @param pFavoriteMode
     */
    public MainListViewAdapter(final MainActivity pMainActivity,
                               final int pFavoriteMode) {
        this.mainActivity = pMainActivity;
        this.favoriteMode = pFavoriteMode;
    }


    /**
     * @return Anzahl der Anzeigen
     */
    @Override
    public int getCount() {
        int devices;
        if (favoriteMode == 0) {
            devices = mainActivity.xml.getDeviceNames().size();
        } else {
            devices = mainActivity.favorite.getFavorites().size();
            favoritenList = new ArrayList<>(mainActivity.favorite.
                    getFavorites());
        }
        return devices;
    }

    /**
     * @param position
     * @return
     */
    @Override
    public Object getItem(final int position) {

        return null;
    }

    /**
     * @param position
     * @return
     */
    @Override
    public long getItemId(final int position) {

        return 0;
    }

    /**
     * @param i
     * @param view
     * @param viewGroup
     * @return view
     */
    @Override
    public View getView(final int i, View view,
                        final ViewGroup viewGroup) {
        view = mainActivity.getLayoutInflater().inflate(R.layout.
                        listview_layout, null);
        TextView textViewName = (TextView) view.findViewById(
                R.id.textName);
        LinearLayout linearLayoutPin = (LinearLayout) view.findViewById(
                R.id.idLinearLayoutPins);
        ImageView buttonViewFavoriten = (ImageView) view.findViewById(
                R.id.imageButtonFavoriten);
        if (favoriteMode == 0) {
            deviceName = mainActivity.xml.getDeviceNames().get(i);
        } else {
            deviceName = mainActivity.favorite.getFavorites().get(i);
        }

        if (mainActivity.favorite.getFavorites().contains(
                deviceName)) {
            favoriteImage = android.R.drawable.btn_star_big_on;
        } else {
            favoriteImage = android.R.drawable.btn_star_big_off;
        }

        buttonViewFavoriten.setOnClickListener(
                new View.OnClickListener() {
                    @Override
                    public void onClick(final View view) {

                        if (favoriteMode == 0) {
                            deviceName = mainActivity.xml.getDeviceNames().
                                    get(i);
                        } else {
                            List<String> test = favoritenList;
                            deviceName = favoritenList.get(i);
                        }
                        if (mainActivity.favorite.getFavorites().contains(
                                deviceName)) {
                            mainActivity.favorite.removeFavorite(
                                    deviceName);
                            favoriteImage = android.R.drawable.btn_star_big_off;
                            buttonViewFavoriten.setImageResource(
                                    favoriteImage);
                        } else {
                            mainActivity.favorite.addFavorite(
                                    deviceName);
                            favoriteImage = android.R.drawable.btn_star_big_on;
                            buttonViewFavoriten.setImageResource(
                                    favoriteImage);
                        }
                    }
                });

        mainActivity.uebergabe.read(deviceName,
                new Response.Listener<JSONObject>() {
            @Override
            public void onResponse(final JSONObject response) {
                if (favoriteMode == 0) {
                    deviceName = mainActivity.xml.getDeviceNames().get(i);
                } else {
                    deviceName = mainActivity.favorite.getFavorites().get(i);
                }
                try {
                    JSONObject state = response.getJSONObject("state");
                    List<String> pinValues = new ArrayList<>();
                    for (String pinName: ((List<String>) mainActivity.xml.
                            getPort(deviceName).
                            get("pins"))) {
                        pinValues.add(state.getString(pinName));
                    }
                    PinView pinView = new PinView(mainActivity, deviceName,
                            pinValues);
                    for (int j = 0; j < ((List<String>) mainActivity.xml.
                            getPort(deviceName).
                            get("pins")).size(); j++) {
                        linearLayoutPin.addView(pinView.getView(j));
                    }
                } catch (JSONException e) {
                                                                // Richtigen log erstellen
                    e.printStackTrace();
                }

            }
        });
        String name = null;
        switch ((mainActivity.xml.getPort(deviceName)).get("protocol").
                toString()) {
            case "PWM":
                name = ((mainActivity.xml.getPort(deviceName)).get("protocol").
                        toString() + ": " + deviceName + " (" + (mainActivity.
                        xml.getPort(deviceName)).get("frequency").toString()
                        + "Hz)");
                break;
            default:
                name = ((mainActivity.xml.getPort(deviceName)).get("protocol").
                        toString() + ": " + deviceName);
                break;
        }
        textViewName.setText(name);
        buttonViewFavoriten.setImageResource(favoriteImage);
        return view;
    }
}
