package com.example.aped.ui.visualization;

import android.content.Intent;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import com.android.volley.Response;
import com.example.aped.MainActivity;
import com.example.aped.R;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

public class PinView {
    private MainActivity mainActivity;

    private int image;
    private List<String> pinValues;
    private  String deviceName;


    public PinView(MainActivity pMainActivity,String pDevice, List<String> pPinValues){
        this.mainActivity = pMainActivity;
        this.deviceName = pDevice;
        this.pinValues = pPinValues;
    }

    public View getView(final int i) {
        View view = mainActivity.getLayoutInflater().inflate(R.layout.pin_listview_layout,
                null);
        ImageView imageView = (ImageView) view.findViewById(
                R.id.images);
        TextView textViewPin = (TextView) view.findViewById(
                R.id.textPin);


        view.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(final View view) {
                if((mainActivity.xml.getPort(deviceName)).get("protocol").toString().equals("DO"))  {
                    try {//                                                        Werte erst aktualisieren
                        String setState = null;
                        if(pinValues.get(i).equals("0")) {
                             setState = "{\"output\": \"1\"}";
                        }else{
                            setState = "{\"output\": \"0\"}";
                        }
                        JSONObject jsonObject = new JSONObject(setState);
                        mainActivity.uebergabe.write(deviceName, jsonObject, new Response.Listener<JSONObject>() {
                            @Override
                            public void onResponse(JSONObject response) {
                                try {
                                    if (!jsonObject.equals(response)) {
                                        //                                       Fehler
                                    }
                                    switch (response.getInt("output")){
                                        case 1:
                                            image = R.drawable.green_signal;
                                            break;
                                        case 0:
                                            image = R.drawable.red_signal;
                                            break;
                                        default:
                                            image = R.drawable.off_signal;
                                            break;
                                    }
                                    imageView.setImageResource(image);

                                } catch (JSONException e) {
                                    e.printStackTrace();
                                }
                            }
                        });
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

                }else{
                    Toast.makeText(mainActivity, deviceName
                                    + " is not an output " ,
                            Toast.LENGTH_SHORT).show();
                }
                mainActivity.uebergabe.read(deviceName,
                        new Response.Listener<JSONObject>() {
                            @Override
                            public void onResponse(final JSONObject response) {
                                try {
                                    JSONObject state = response.getJSONObject("state");
                                    //List<String> pinValues = new ArrayList<>();
                                    pinValues.clear();
                                    for(String pinName: ((List<String>)mainActivity.xml.
                                            getPort(deviceName).
                                            get("pins"))){
                                        pinValues.add(state.getString(pinName));
                                    }
                                    switch (pinValues.get(i)){
                                        case "1":
                                            image=R.drawable.green_signal;
                                            break;
                                        case "0":
                                            image=R.drawable.red_signal;
                                            break;
                                        default:
                                            image=R.drawable.off_signal;
                                            break;
                                    }
                                    imageView.setImageResource(image);

                                } catch (JSONException e) {
                                    // Richtigen log erstellen
                                    e.printStackTrace();
                                }

                            }
                        });
            }
        });

        switch (pinValues.get(i)){
            case "1":
                image=R.drawable.green_signal;
                break;
            case "0":
                image=R.drawable.red_signal;
                break;
            default:
                image=R.drawable.off_signal;
                break;
        }
        imageView.setImageResource(image);


        textViewPin.setText(((List<String>) (mainActivity.xml.getPort(deviceName)).get("pins")).get(i));
        return view;
    }
}
